from pathlib import Path

from model_server.util import autonumber_new_directory, get_matching_files, loop_workflow
from extensions.chaeo.workflows import export_patches_from_multichannel_zstack

# TODO: support list-comp of single image sequence in multiple locations

# TODO: split multi-pos CZI into sequence of accessors, append to list

if __name__ == '__main__':
    root = Path('c:/Users/rhodes/projects/proj0012-trec-handoff/owncloud-sync/TREC-HD/Images/')
    where_czi = (root / 'TREC_STOP_24_Bilbao/231008_automic/20231008-162336/Selection').__str__()
    where_output = autonumber_new_directory(
        'c:/Users/rhodes/projects/proj0011-plankton-seg/exp0017',
        'batch-output'
    )

    px_ilp = Path('c:/Users/rhodes/projects/proj0011-plankton-seg/exp0017/pxAF405_dim8bit.ilp').__str__()

    params = {
        'ilastik_project_file': px_ilp,
        'pxmap_threshold': 0.25,
        'pixel_class': 0,
        'zmask_channel': 0,
        'zmask_zindex': 3,
        'patches_channel': 2,
        'mask_type': 'boxes',
        'zmask_filters': {'area': (1e3, 1e8)},
        'zmask_expand_box_by': (128, 3),
        'export_pixel_probabilities': True,
        'export_2d_patches_for_training': True,
        'draw_bounding_box_on_2d_patch': True,
        'export_2d_patches_for_annotation': True,
        'export_3d_patches': False,
        'export_annotated_zstack': True,
        'export_patch_masks': True,
        'rescale_zmask_clip': 0.01,
        'rgb_overlay_channels': (1, None, None),
        'rgb_overlay_weights': (0.5, 1.0, 1.0)
    }

    input_files = get_matching_files(where_czi, 'czi', coord_filter={})

    loop_workflow(
        input_files,
        where_output,
        export_patches_from_multichannel_zstack,
        params,
        catch_and_continue=False,
    )

    print('Finished')